require 'openssl'

module EncryptedYaml
  # Handles decryption
  # @note uses AES256
  class Decrypt
    # @param key [String] encryption key
    # @param iv [String] encyption iv
    def initialize(key, iv)
      @key = key
      @iv = iv
    end

    # @param data [String] encrypted data
    # @return [String] decrypted data
    def decrypt(data)
      cipher = get_cipher
      cipher.update(data) + cipher.final
    end

    private

    # @return [OpenSSL::Cipher] initialized cipher ready for decryption
    def get_cipher
      cipher = OpenSSL::Cipher::AES256.new :CBC
      cipher.decrypt
      cipher.key = @key
      cipher.iv = @iv
      
      cipher
    end
    
  end
end